use strict;
use warnings;
use lib '/usr/local/monitoring/collectd/lib/collectd/perl';
use Collectd qw( :all );
 
 #UTIL FUNCTION
no warnings 'all';
 
# plugin name
my $CFG_plugin_name = "pping";

my $list_size; # added by Hanine
 
sub fping {
my $filename =  "/root/text.txt" ;
open IN, '<', $filename or die;
my @managed_servers_list = <IN>;
close IN;
my $tm = time();
 
foreach (@managed_servers_list) {
chomp($_);
my $ping_stat = `fping $_` ;
chomp($ping_stat);
if ($ping_stat =~  /is alive/) {
        my $v = {
                 severity => NOTIF_OKAY,
                 time     => $tm,
                 message  => $ping_stat,
                 plugin   => $CFG_plugin_name,
                 type     => 'ping_status',
                 meta     => [ { name => 'num_of_servers', value => $list_size } ]
                };
       plugin_dispatch_notification ($v);
}else{
        my $v = {
                 severity => NOTIF_FAILURE,
                 time     => $tm,
                 message  => $ping_stat,
                 plugin   => $CFG_plugin_name,
                 type     => 'ping_status',
                 meta     => [ { name => 'num_of_servers', value => $list_size } ]
                };
       plugin_dispatch_notification ($v);
}
}
}
 
sub read_ping_stat {
        fping();
        return 1;
}
 
plugin_register(TYPE_READ, $CFG_plugin_name, "read_ping_stat");
1;
